# OpalLocalMediaStream Class Reference

`#include <localep.h>`

Inheritance diagram for OpalLocalMediaStream:

[legend]
Collaboration diagram for OpalLocalMediaStream:
[legend]

## Public Member Functions

Construction
| OpalLocalMediaStream (OpalLocalConnection &conn, const OpalMediaFormat &mediaFormat, unsigned sessionID, bool isSource, OpalLocalEndPoint::Synchronicity synchronicity)
Overrides of OpalMediaStream class
virtual PBoolean | ReadPacket (RTP_DataFrame &packet)
virtual PBoolean | WritePacket (RTP_DataFrame &packet)
virtual PBoolean | ReadData (BYTE *data, PINDEX size, PINDEX &length)
virtual PBoolean | WriteData (const BYTE *data, PINDEX length, PINDEX &written)
virtual PBoolean | IsSynchronous () const

## Protected Member Functions

virtual void | InternalClose ()

## Protected Attributes

OpalLocalEndPoint::Synchronicity | m_synchronicity

## Detailed Description

Local media stream. This class represents a media stream on the local machine that can receive media via virtual functions.

## Constructor & Destructor Documentation

OpalLocalMediaStream::OpalLocalMediaStream | ( | OpalLocalConnection & | conn,
|  | const OpalMediaFormat & | mediaFormat,
|  | unsigned | sessionID,
|  | bool | isSource,
|  | OpalLocalEndPoint::Synchronicity | synchronicity |
| ) |  |  |

Construct a new media stream for local system.

Parameters:

  conn | Connection for media stream
  mediaFormat | Media format for stream
  sessionID | Session number for stream
  isSource | Is a source stream
  synchronicity | Synchronous mode

## Member Function Documentation

virtual void OpalLocalMediaStream::InternalClose | ( |  | ) | `[inline, protected, virtual]`

Close any internal components of the stream. This should be used in preference to overriding the Close() function as it is guaranteed to be called exactly once and avoids race conditions in the shut down sequence of a media stream.

Implements OpalMediaStream.

virtual PBoolean OpalLocalMediaStream::IsSynchronous | ( |  | ) | const`[virtual]`

Indicate if the media stream is synchronous. Returns true for LID streams.

Implements OpalMediaStream.

virtual PBoolean OpalLocalMediaStream::ReadData | ( | BYTE * | data,
|  | PINDEX | size,
|  | PINDEX & | length |
| ) |  |  | `[virtual]`

Read raw media data from the source media stream. The default behaviour reads from the OpalLine object.

Parameters:

  data | Data buffer to read to
  size | Size of buffer
  length | Length of data actually read

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLocalMediaStream::ReadPacket | ( | RTP_DataFrame & | packet | ) | `[virtual]`

Read an RTP frame of data from the source media stream. The default behaviour simply calls ReadData() on the data portion of the RTP_DataFrame and sets the frames timestamp and marker from the internal member variables of the media stream class.

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLocalMediaStream::WriteData | ( | const BYTE * | data,
|  | PINDEX | length,
|  | PINDEX & | written |
| ) |  |  | `[virtual]`

Write raw media data to the sink media stream. The default behaviour writes to the OpalLine object.

Parameters:

  data | Data to write
  length | Length of data to read.
  written | Length of data actually written

Reimplemented from OpalMediaStream.

virtual PBoolean OpalLocalMediaStream::WritePacket | ( | RTP_DataFrame & | packet | ) | `[virtual]`

Write an RTP frame of data to the sink media stream. The default behaviour simply calls WriteData() on the data portion of the RTP_DataFrame and and sets the internal timestamp and marker from the member variables of the media stream class.

Reimplemented from OpalMediaStream.

## Field Documentation

OpalLocalEndPoint::Synchronicity OpalLocalMediaStream::m_synchronicity `[protected]`

The documentation for this class was generated from the following file:

- localep.h